#define _CASO3_ 

#include "caso3.h"
#include "main.h"
#include "cpu.h"
#include "casoed.h"


void runBit(char b,char valor);
int runCB(void);
int runROT(unsigned char ny,unsigned char nz);


int caso3(unsigned char c)
	{
		switch(nz)
		{
		 case 0:	
				if(tipePrint==1) sprintf(cnemo,"RET %s",fReg[ny]);
				if(1==getF(ny)) return(1);
				alu16.b.l=memoria[rSP]; rSP++; 
				alu16.b.h=memoria[rSP];	rSP++; 
				xPC =alu16.w;	
				return(-2);				
		 break;
		 
		 case 1:
			if(nq==0)
				{
					if(tipePrint==1) 	sprintf(cnemo,"POP %s",qqReg2[np]);
					 alu16.b.l=memoria[rSP]; rSP++;
					 alu16.b.h=memoria[rSP]; rSP++;
					switch(np)
					{
					 case 0:
						bc.w=alu16.w;
					 break;
					 case 1:
						de.w=alu16.w;
					 break;
					 case 2:
						hl.w=alu16.w;
					 break;
					 case 3:
						af.w=alu16.w;
						FromAF();
					 break;
					}					
				}
				else
				{
				  switch(np)
					{
					 case 0:
						alu16.b.l=memoria[rSP]; rSP++; 
						alu16.b.h=memoria[rSP]; rSP++; 
						xPC =alu16.w;		
						if(tipePrint==1) sprintf(cnemo,"RET ");
					 break;
					 case 1:
						if(tipePrint==1) sprintf(cnemo,"EXX");
						alu16.w=bc.w;	af.w=bc2.w;	 bc2.w=alu16.w;
						alu16.w=de.w;	af.w=de2.w;	 de2.w=alu16.w;
						alu16.w=HL.w;	af.w=HL2.w;	 HL2.w=alu16.w;				 		
					 break;
						
					 case 2:
						alu16.w=hl.w;			
						if(tipePrint==1) 	sprintf(cnemo,"JP %s",qqReg[2+modo]);
						xPC=alu16.w;					
						return(-2);		

					 break;
					 case 3:
						alu16.w=hl.w;		
						if(tipePrint==1) 	sprintf(cnemo,"LD SP,%s",qqReg[2+modo]);
					 	rSP=hl.w;
					 break;
					}
					
				}
		 break;
		 
		 case 2: 
			xPC++; alu16.b.l=memoria[xPC];			
			xPC++; alu16.b.h=memoria[xPC];
			if(tipePrint==1)  sprintf(cnemo,"JP %s,%d",fReg[ny],alu16.w);
			if(getF(ny)==1)	 { xPC=alu16.w;	return(-2);}
		 break;
		
		
		  case 3:
			switch(ny)
				{
				 case 0:
					xPC++; alu16.b.l=memoria[xPC];			
					xPC++; alu16.b.h=memoria[xPC];
					if(tipePrint==1)  sprintf(cnemo,"JP %d",alu16.w);
					xPC=alu16.w;					
					return(-2);					
				 break;
				 case 1:
					//if(tipePrint==1) printf("BC ");
					return(runCB());
				 break;
				 case 2:
				 	xPC++; alu16.b.l=memoria[xPC];
				 	OUTz80(alu16.b.l,af.b.h);
				 	if(tipePrint==1)  	sprintf(cnemo,"OUT (%d),A",alu16.b.l);
				 break;
				 case 3:
					xPC++; alu16.b.l=memoria[xPC];
					af.b.h=INz80(alu16.b.l);
					if(tipePrint==1)  	sprintf(cnemo,"IN A,(%d)",alu16.b.l);
				 break;
				 case 4:
					if(tipePrint==1)  	sprintf(cnemo,"EX (SP),HL");
					alu=memoria[rSP]; memoria[rSP]=hl.b.l; hl.b.l=alu;
					alu=memoria[rSP+1]; memoria[rSP+1]=hl.b.h; hl.b.h=alu; 
				 break;
				 case 5:
					if(tipePrint==1)  sprintf(cnemo,"EX DE,HL");
					alu16.w=de.w;
					de.w=hl.w;
					hl.w=alu16.w;
				 break;
				 case 6:
					if(tipePrint==1)  	sprintf(cnemo,"DI");
					rI=0;
				 break;
				 case 7:
					if(tipePrint==1)  	sprintf(cnemo,"EI");
					rI=1; 
				 break;
				}		
		   break;
		   
		   case 4:
				xPC++; alu16.b.l=memoria[xPC];			
				xPC++; alu16.b.h=memoria[xPC];
				if(tipePrint==1)	sprintf(cnemo,"CALL %s %d",fReg[ny],alu16.w);
				if(1==getF(ny)) return(1);
				alu16i.w=xPC;
				xPC=alu16.w;								
				rSP--;memoria[rSP]=alu16i.b.h; 
				rSP--;memoria[rSP]=alu16i.b.l; 								
				return(-2);					 		 
		   break;
		   
		   case 5:		 
				if(nq==0)
					{
						if(tipePrint==1)	sprintf(cnemo,"PUSH %s",qqReg2[np]);
						switch(np)
							{
							 case 0:
								alu16.w=bc.w;
							 break;
							 case 1:
								alu16.w=de.w;
							 break;
							 case 2:
								alu16.w=hl.w;
							 break;
							 case 3:
								toAF();								
								alu16.w=af.w;
							 break;
							}			
						rSP--; memoria[rSP]=alu16.b.h ; 
						rSP--; memoria[rSP]=alu16.b.l ; 

					}
					else
					{
					  switch(np)
						{
						 case 0:
								xPC++; alu16.b.l=memoria[xPC];			
								xPC++; alu16.b.h=memoria[xPC];
								alu16i.w=xPC;
								 if(tipePrint==1)	sprintf(cnemo,"CALL %d",alu16.w);
								xPC=alu16.w;								
								rSP--; memoria[rSP]=alu16i.b.h; 
								rSP--; memoria[rSP]=alu16i.b.l; 								
								return(-2);
						 break;
						 case 1:
							printf("---ERROR DD-c3-%d-%d--\n",nz,np); return(-1);
						 break;
						 case 2:
							//printf("-ed-");
							return(casoed(c));
						 break;
						 case 3:
							printf("---ERROR FD-c3-%d-%d--\n",nz,np);	return(-1);
						 break;
						}
						
					}	 
		   break;
		
		   case 6:
				switch(ny)
					{
						case 0:
							if(tipePrint==1)	sprintf(cnemo,"ADD A,n");
							xPC++;	alu=memoria[xPC];
							alu+=af.b.h;
							af.b.h=alu;
							setF();
						break;
						case 1:
							if(tipePrint==1)	sprintf(cnemo,"ADC n");
							xPC++;	alu=memoria[xPC];
							alu+=regF1.CF;	alu+=af.b.h;
							af.b.h=alu;
							setF();
						break;
						case 2:
							if(tipePrint==1)	sprintf(cnemo,"SUB n");
							xPC++;	alu=memoria[xPC];
							alu=af.b.h-alu;	
							af.b.h=alu;
							setF();
						break;
						case 3:
							if(tipePrint==1)	sprintf(cnemo,"SBC n");
							xPC++;	alu=memoria[xPC];
							alu=af.b.h-alu-regF1.CF;
							af.b.h=alu;
							setF();
						break;
						case 4:
							if(tipePrint==1)	sprintf(cnemo,"AND n");
							xPC++;	alu=memoria[xPC];
							alu&=af.b.h;
							af.b.h=alu;
							setF();
						break;
						case 5:
							if(tipePrint==1)	sprintf(cnemo,"XOR n");
							xPC++;	alu=memoria[xPC];
							alu^=af.b.h;
							af.b.h=alu;
							setF();
						break;
						case 6:
							if(tipePrint==1)	sprintf(cnemo,"OR n");
							xPC++;	alu=memoria[xPC];
							alu|=af.b.h;
							af.b.h=alu;
							setF();
						break;
						case 7:
							if(tipePrint==1)	sprintf(cnemo,"CP n");
							xPC++;	alu=memoria[xPC];
							alu=af.b.h-alu;
							setF();
						break;	
					}
		 break;
		 case 7:
				alu16.w=xPC;
				rSP--; memoria[rSP]=alu16.b.h; 
				rSP--; memoria[rSP]=alu16.b.l; 						 
				alu16.b.l=ny*8;							
				alu16.b.h=0;
				xPC=alu16.w;
				if(tipePrint==1)	sprintf(cnemo,"RST %d",alu16.w);					
				return(-2);
		 break;
			
		}
	
	 return(1);						
	}



int runROT(unsigned char ny,unsigned char nz)
{
 int tmp;
		switch(ny)
			{
			 case 0:
				if(tipePrint==1)		sprintf(cnemo,"RLC %s",cReg[nz]);
				regToAlu(nz);
				alu<<=1;
				if(alu & 256) alu|=1; else alu&=254;
				setF();
				aluToReg(nz);
			 break;
			 case 1:
				 if(tipePrint==1)	  sprintf(cnemo,"RRC %s",cReg[nz]);
				regToAlu(nz);					
				if((alu&1)==1)
					{	alu>>=1;	alu|=128;	alu|=256;}
					else
					{	alu>>=1;	alu&=127;	alu&=255;}
				  
				setF();
				aluToReg(nz);
			 break;
			 case 2:
				 if(tipePrint==1)	  sprintf(cnemo,"RL %s",cReg[nz]);
				regToAlu(nz);						
				if(regF1.CF==1)
					{	alu<<=1;	alu|=1;	}
					else
					{	alu<<=1;	alu&=65534;	}
				  
				setF();
				aluToReg(nz);				 
			break;
			 case 3:
				if(tipePrint==1)	  sprintf(cnemo,"RR %s",cReg[nz]);
				regToAlu(nz);	
				tmp=alu&1;					
				if(regF1.CF==1)
					{	alu>>=1;	alu|=128;	}
					else
					{	alu>>=1;	alu&=127;	}
				if(tmp==1)
					{alu|=256;}
					else
					{alu&=0x2ff;}
				setF();
				aluToReg(nz);
			 break;
			 case 4:
				if(tipePrint==1)	  sprintf(cnemo,"SLA %s",cReg[nz]); 
				regToAlu(nz);	alu<<=1;  
				setF();			aluToReg(nz);	
			 break;
			 case 5:
				if(tipePrint==1)	  sprintf(cnemo,"SRA %s",cReg[nz]);
				regToAlu(nz);	
				alu16.b.l=alu&128;					
				alu>>=1;
				if(alu16.b.l==128)	{alu|=128;}
				setF();			aluToReg(nz);
			 break;
			 case 6:
				if(tipePrint==1)	  sprintf(cnemo,"SLL %s",cReg[nz]);
				return(-1);
			 break;
			 case 7:
				if(tipePrint==1)	  sprintf(cnemo,"SRL %s",cReg[nz]);
				regToAlu(nz);
				if(alu&1)
					{ alu>>=1;	alu|=256; }
				else
					{ alu>>=1;	alu&=0x2ff; }
				setF();			
				aluToReg(nz);	
			 break;
			 default:
			  printf("---ERROR- caso=%d  nz=%d-ny=%d- \n",nx,nz,ny);return(-1);	
			 break;
		}
 return(1);
}


void runBit(char b,char valor)
{
  unsigned char n;
		n=1;	n<<=b;
		switch(valor)
				{
				 case 0: 
					n=~n;	alu&=n;
				 break;
				 case 1:
				  alu|=n;
				 break;
				 case 2:
				  if((alu&n)==n) regF1.ZF=0; else regF1.ZF=1;
				 break;
				}		
}

int runCB(void)
{
 unsigned char c,ny,nz,nx;
		xPC++; c=memoria[xPC];
		nx=(c & 192)>>6;	 ny=(c & 56)>>3;	 nz=(c & 7);
		switch(nx)
		{
		 case 0:
			return(runROT(ny,nz));			
		 break;
		 case 1:	
			if(tipePrint==1)			sprintf(cnemo,"BIT %d,%s",ny,cReg[nz]);
			regToAlu(nz); runBit(ny,2); aluToReg(nz); 
		 break;
		 case 2:	
			if(tipePrint==1)			sprintf(cnemo,"RES %d,%s",ny,cReg[nz]);
			regToAlu(nz); runBit(ny,0); aluToReg(nz); 
		 break;
		 case 3:
			if(tipePrint==1)			sprintf(cnemo,"SET %d,%s",ny,cReg[nz]);
			regToAlu(nz); runBit(ny,1); aluToReg(nz); 
		 break;
		}	
	return(1);
}




