
#ifdef _CPU_
/* Declaraciones originales - activas sólo en el módulo raíz */

    void sleepcp(int milliseconds);
    void Reset(void);

    unsigned char INz80(unsigned int port);
    void OUTz80(unsigned int port,unsigned char valor);

	void regToAlu(unsigned char r);
	void aluToReg(unsigned char r);

	char getF(unsigned char x);
    void setF(void);

	void regToAlu32(unsigned char r);
	void Alu32ToReg(unsigned char r);
	
	char * printReg8_d(unsigned char r);
	char * printReg8_s(unsigned char r);
	
	void toAF(void);
	void FromAF(void);
	
#else
/* Referencias externas - para módulos distintos al raíz */	

    extern void sleepcp(int milliseconds);
    extern void Reset(void);
    
    extern unsigned char INz80(unsigned int port);
    extern void OUTz80(unsigned int port,unsigned char valor);

	extern void regToAlu(unsigned char r);
	extern void aluToReg(unsigned char r);

	extern char getF(unsigned char x);
    extern void setF(void);

	extern void regToAlu32(unsigned char r);
	extern void Alu32ToReg(unsigned char r);
	
	extern char * printReg8_d(unsigned char r);
	extern char * printReg8_s(unsigned char r);
	
	extern void toAF(void);
	extern void FromAF(void);
	
#endif




