#define _GRAFI_ 

#include "grafi.h"
#include "main.h"

 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
 #include <stdio.h>


 /* ------ Fin de funciones para fuentes ------ */

// eventos teclado
int eventosT(void)
{
  int SimbolKey=-1;	
	 while( SDL_PollEvent( &event ) )
		{			
			switch (event.type)			
			{				
				case	SDL_KEYDOWN:
						SimbolKey=event.key.keysym.sym;
						//printf("Evento Tecla SimbolKey=%d \n",SimbolKey);
															
						switch (SimbolKey)			
							{	
								case	SDLK_ESCAPE:
										Fquit=1;
										printf("** QUIT **\n");
								break;
								case	SDLK_r:
										
								break;							
							}					
				break;
			}
		}	
	return( SimbolKey);	
}



 int leerFuente(char nombre[],char nombre2[]) 
 {
   fuente.imagen  =IMG_Load(nombre);
   if(!fuente.imagen) return(-1);
   fuente.ancho=256;   fuente.alto=256;
   fuente.anchoLetra=16;   fuente.altoLetra=16;
   fuente.primeraLetra=0;
   
   fuente2.imagen  =IMG_Load(nombre2);
   if(!fuente.imagen) return(-1);
   fuente2.ancho=256;   fuente2.alto=256;
   fuente2.anchoLetra=16;   fuente2.altoLetra=16;
   fuente2.primeraLetra=0;
   return(1);
 }

void  mostrarFuente(int x, int y) 
{
 SDL_Rect destino; 
 destino.x = x;
 destino.y = y;
 SDL_BlitSurface(fuente.imagen, NULL, screen, &destino); 
}



 /* Escribir una letra */
 int escribirLetra(int x, int y, unsigned char letra) {
   SDL_Rect destino, origen;
   int fila, columna;
   int letrasPorFila, letrasPorColumna;

   letrasPorFila = fuente.ancho/fuente.anchoLetra;
   letrasPorFila=letrasPorFila;
   letrasPorColumna = fuente.alto/fuente.altoLetra;
   fila = letra / letrasPorColumna;
   columna = letra % letrasPorColumna;
   origen.x = columna * fuente.anchoLetra;
   origen.y = fila * fuente.altoLetra;
   origen.w = 16;   origen.h = 16;
   destino.x = x;   destino.y = y;
   if(fuentePrint==0)
		SDL_BlitSurface(fuente.imagen, &origen, screen, &destino);
	else
		SDL_BlitSurface(fuente2.imagen, &origen, screen, &destino);
   return(1);
 }

/* Escribir una frase */
 int printATc(int x, int y, unsigned char letra) 
 {
	escribirLetra(x*16, y*16, letra);
   return(1);
 }

 int printATs(int x, int y, char *frase) 
 {
  int i,t;
   t=strlen(frase);
   for (i=0; i<t; i++)   printATc(x+i,y,frase[i]);
   return(1);
 }

int printATn(int x, int y, int numero) 
{
  char cadena[30];
  unsigned char z;
		z=numero;
	   sprintf(cadena,"%02X",z);
	   printATs(x,y,cadena);
	   return(1);
 }
int printATnn(int x, int y, int numero) 
{
  char cadena[30]; 
	   sprintf(cadena,"%04X",numero);
	   printATs(x,y,cadena);
	   return(1);
 }
 
 int printATl(int x, int y, char l) 
{
	   if(l==0) printATc(x,y,'0');  else printATc(x,y,'1');
	   return(1);
 }

 /* Escribir una frase */
 int printS(int x, int y, char *frase) {
  int i,t;
   t=strlen(frase);
   for (i=0; i<t; i++)   escribirLetra(x+i*fuente.anchoLetra, y, frase[i]);
   return(1);
 }
 
 
int printN(int x, int y, unsigned char numero) {
  int i,t;
  char cadena[30]; 
	   sprintf(cadena,"%02X",numero);
	   t=strlen(cadena);
	   for (i=0; i<t; i++)   escribirLetra(x+i*fuente.anchoLetra, y, cadena[i]);
	   return(1);
 }
 
 int printD(int x, int y, int numero) {
  int i,t;
  char cadena[30]; 
	   sprintf(cadena,"%03d",numero);
	   t=strlen(cadena);
	   for (i=0; i<t; i++)   escribirLetra(x+i*fuente.anchoLetra, y, cadena[i]);
	   return(1);
 }
 
 int printNN(int x, int y, int numero) {
  int i,t;
  char cadena[30]; 
	   sprintf(cadena,"%04X",numero);
	   t=strlen(cadena);
	   for (i=0; i<t; i++)   escribirLetra(x+i*fuente.anchoLetra, y, cadena[i]);
	   return(1);
 }
 
 
 int printL(int x, int y, int numero) {
	if(numero==0)
		escribirLetra(x,y,'0');
	else
		escribirLetra(x,y,'1');
   return(1);
 }


//----------Pantalla
void pantalla(void)
{
  int z;
  //int z1;
  
	fuentePrint=0;
	printATs(1, 3, "A=");	printATs(1, 2, "A=");
	printATs(1, 4, "B=");	printATs(1, 5, "C=");	
	printATs(1, 6, "D=");	printATs(1, 7, "E=");	
	printATs(1, 8, "H=");	printATs(1, 9, "L=");	
	
	printATs(8, 3, "A'=");
	printATs(8, 4, "B'=");	printATs(8,5, "C'=");
	printATs(8, 6, "D'=");	printATs(8,7, "E'=");
	printATs(8, 8, "H'="); printATs(8,9, "L'=");
	
	printATs(2,11,"S Z C P");
	printATs(1,12,"'");
	printATs(2,12,"S Z C P");
	
	printATs(1, 14, "PC=");
	printATs(1, 15, "SP=");
	printATs(1, 16, "IX=");
	printATs(1, 17, "IY=");
	printATs(1, 19, "I=");
	printATs(1, 20, "R=");
	printATs(1, 22, "IFF1=");
	printATs(1, 23, "IFF2=");
	if(tipeSP!=-1) 
		{
			printATs(40,2,"-SP-");
			for (z=0;z<20;z++)	{	printATnn(40,4+z,tipeSP-z);	}	
		}
	if(tipeME!=-1) 
		{
			printATs(30,2,"-memory-");
			for (z=0;z<20;z++)	{	printATnn(30,4+z,tipeME+z);	}	
		}
	if(tipePORT!=-1) 
		{
			printATs(20,2,"-PORT-");
			for (z=0;z<10;z++)	{	printATn(20,4+z,tipePORT+z); }	
		}
	//Video
	for(z=0;z<18;z++)	{	printATc(z,29,219);	printATc(z,30,219);printATc(z,31,219); printATc(z,32,219);}
	//for(z=19;z<29;z++)	for(z1=26;z1<36;z1++)	{	 printATc(z,z1,2);		}	
}


char* toBinary(unsigned char n)
{
 unsigned x;
    for (x=0;x<8;x++) 
    {
		if(n&128) tmps[x]='1'; else tmps[x]='0';
		n=n<<1;
    }
    tmps[x] = 0;
    return (tmps);
}


void printReg(void)
{
  int z;
	fuentePrint=1;
	printATs(3, 2, toBinary(af.b.h));
	printATn(3, 3, af.b.h);
	printATn(3, 4, bc.b.h);	printATn(3, 5, bc.b.l);	
	printATn(3, 6, de.b.h);	printATn(3, 7, de.b.l);	
	printATn(3, 8, HL.b.h);	printATn(3, 9, HL.b.l);	
	
	printATn(11, 3, af2.b.h);
	printATn(11, 4, bc2.b.h);	printATn(11,5, bc2.b.l);
	printATn(11, 6, de2.b.h);	printATn(11,7, de2.b.l);
	printATn(11, 8, HL2.b.h);  printATn(11,9, HL2.b.l);
	
	printATnn(4,14,rPC);
	printATnn(4,15,rSP);
	printATnn(4,16,IX);
	printATnn(4,17,IY);
	
	printATn(3,19,rI);
	printATn(3,20,rR);
	
	printATl(6,22,rIFF1);
	printATl(6,23,rIFF2);
	
	printATl(3,11,regF1.SF);	printATl(5,11,regF1.ZF);	printATl(7,11,regF1.CF);	printATl(9,11,regF1.PF);
	printATl(3,12,regF2.SF);	printATl(5,12,regF2.ZF);	printATl(7,12,regF2.CF);	printATl(9,12,regF2.PF);
	//printf(" tipeSP=%d ",tipeSP);
	if(tipeSP!=-1) 
		{
			for (z=0;z<20;z++)	{ printATc(44,4+z,' ');	printATn(45,4+z,memoria[tipeSP-z]);	}	
			printATc(44,4+(tipeSP-rSP),'>');
		}
	if(tipeME!=-1) 
		{
			for (z=0;z<20;z++)	{ printATn(35,4+z,memoria[tipeME+z]);  printATc(38,4+z,memoria[tipeME+z]);	}	
		}
	if(tipePORT!=-1) 
		{
			for (z=0;z<10;z++)	{ printATn(23,4+z,puertos[tipePORT+z]);	}	
		}
}




void setColor(unsigned char r,unsigned char g,unsigned char b)
{
	ColorDefault.r=r;	ColorDefault.g=g;	ColorDefault.b=b;
}
void pantaGrafica(int x,int y,SDL_Color color)
{
  int xx,yy,x1,y1;
  char *buffer;
  char *direccolor;
  unsigned int col,col0;
  int me=16384;
  unsigned char count,valor;
   
	col=SDL_MapRGB(screen->format,color.r,color.g,color.b);
	col0=SDL_MapRGB(screen->format,0,0,0);

	x1=x+128; y1=y+128; count=8; 
	for(yy=y;yy<y1;yy++)
		for(xx=x;xx<x1;xx++)		
			{
				buffer=(char*) screen->pixels;
				buffer+=screen->pitch*yy;
				buffer+=screen->format->BytesPerPixel*xx;
				if(count==8) {	valor=memoria[me]; me++; count=0; }
				
				if(128&valor)	direccolor=(char*) &col; else  direccolor=(char*) &col0;
				valor=valor<<1; count++;
				switch (screen->format->BytesPerPixel)			
						{	
							case 4:
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
							break;	
							case 3:
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
							break;						
							case 2:
								*(buffer++)=*(direccolor++);
								*(buffer++)=*(direccolor++);
							break;
							case 1:
								*(buffer++)=*(direccolor++);
							break;				
						}							
			}
}

