#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <SDL/SDL.h>

 
struct tipoFuente{
   SDL_Surface *imagen;
   int ancho, alto;
   int anchoLetra, altoLetra;
   int primeraLetra;
 };

#ifdef _GRAFI_
/* Declaraciones originales - activas sólo en el módulo raíz */

	struct tipoFuente fuente,fuente2;
	void pantalla(void);
	void pantalla1(void);
	unsigned char fuentePrint;
	int leerFuente(char nombre[],char nombre2[]);
	int escribirLetra(int x, int y, unsigned char letra);
	int printS(int x, int y, char *frase);
	int printATc(int x, int y, unsigned char letra);
	int printATs(int x, int y, char *frase);
	int printATn(int x, int y, int numero); 
	int printATnn(int x, int y, int numero);
	int printATl(int x, int y, char l);
	
	void setColor(unsigned char r,unsigned char g,unsigned char b);
	void pantaGrafica(int x,int y,SDL_Color color);
	
	int eventosT(void);
	int Fquit;
	SDL_Event event;
	void mostrarFuente(int x, int y);
	void printReg(void);
	
	
#else
/* Referencias externas - para módulos distintos al raíz */
	extern struct tipoFuente fuente,fuente2;
	extern void pantalla(void);
	extern void pantalla1(void);
	extern unsigned char fuentePrint;
	extern int leerFuente(char nombre[],char nombre2[]);
	extern int escribirLetra(int x, int y, unsigned char letra);
	extern int printS(int x, int y, char *frase);
	extern int printATc(int x, int y, unsigned char letra);
	extern int printATs(int x, int y, char *frase);
	extern int printATn(int x, int y, int numero);
	extern int printATnn(int x, int y, int numero) ;
	extern int printATl(int x, int y, char l);
	
	extern void setColor(unsigned char r,unsigned char g,unsigned char b);
	extern void pantaGrafica(int x,int y,SDL_Color color);
	 
	extern int eventosT(void);
	extern int Fquit;
	extern SDL_Event event;
	extern void mostrarFuente(int x, int y);
	extern void printReg(void);
	

#endif

