 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
 
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <SDL/SDL.h>

struct regF
{
	unsigned SF;
	unsigned ZF;
	unsigned YF;
	unsigned HF;
	unsigned XF;
	unsigned PF;
	unsigned NF;
	unsigned CF;
} ;

#ifdef _MAIN_
/* Declaraciones de variables locales */
unsigned char memoria[65536]; 
unsigned char puertos[256]; 
SDL_Surface *screen; /* La pantalla */ 
SDL_Color ColorDefault;

uint16_t rPC,rSP;
unsigned char rI,rR,rIFF1,rIFF2;
unsigned eNMI,eINT;

typedef union 
 {
  struct { unsigned char l,h; } b;
  uint16_t w;
} regpair; 

regpair af,bc,de,hl,alu16,alu16i;
regpair af2,bc2,de2;
regpair HL,HL2;
uint16_t hlm,IX,IY;
struct regF regF1,regF2;

uint16_t  xPC=0,xSP=0;
unsigned char nx,ny,nz,np,nq;
uint16_t  alu;
uint32_t  alu32;
char des;

int tipeSP;
int tipeME;
int tipeVI;
int tipePORT;
unsigned tipeNMI,tipeINT;

unsigned char modo;

int tipePrint;
char cnemo[30];
char cReg[12][10]={"B","C","D","E","H","L","(HL)","A","(IX+","(IY+"};
char fReg[10][4]={"NZ","Z","NC","C","PO","PE","P","M"};
char qqReg[8][4]={"BC","DE","HL","SP","IX","IY"};
char qqReg2[8][4]={"BC","DE","HL","AF"};

char tmps[20];
char tmpd[20];
                 
#else
/* Referencias externas - para módulos distintos al raíz */
extern struct tipoFuente fuente;
extern unsigned char memoria[65536]; 
extern unsigned char puertos[256]; 
extern SDL_Surface *screen; /* La pantalla */
extern SDL_Color ColorDefault;

extern uint16_t rPC,rSP;
extern unsigned char rI,rR,rIFF1,rIFF2;

typedef union 
 {
  struct { unsigned char l,h; } b;
  uint16_t w;
} regpair; 

extern regpair af,bc,de,hl,alu16,alu16i;
extern regpair af2,bc2,de2;
extern regpair HL,HL2;
extern uint16_t hlm,IX,IY;
extern struct regF regF1,regF2;
extern unsigned eNMI,eINT;

extern uint16_t  xPC,xSP;
extern unsigned char nx,ny,nz,np,nq;
extern uint16_t  alu;
extern uint32_t  alu32;
extern char des;

extern int tipeSP;
extern int tipeME;
extern int tipeVI;
extern int tipePORT;
extern unsigned char modo;

extern int tipePrint;
extern char cnemo[30];
extern char cReg[12][10];
extern char fReg[10][4];
extern char qqReg[8][4];
extern char qqReg2[8][4];

extern char tmps[20];
extern char tmpd[20];

#endif
