#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define LINEMAX 500
#define VARMAX 100

int quitarFinLinea(void);
int Mayusculas(void);
int quitarSPACE(void);
int changeSrt(char *cadena, char *busqueda, char *cambio);

int preprocesador(int modo);


int cambioEtiquetas(int modo,char c);
int buscarNumero(void);
int buscarEtiquetas(int modo);

int setBytes(int n);
int setString(void);

                      
struct VARIABLES { char nombre[12]; int valor; };
struct VARIABLES variables[VARMAX];
int nvariables;


FILE *pf, *pfasm;
char lineaE[LINEMAX];
char lineaEe[LINEMAX*2];

char etiqueta[20]="";
int indice;

//----------------------------------------------

int buscarCode(void);

void printVariables(void);
void printError(void);

int saveCodigo(int modo);

#include "nemaz80.h"

char trozo0[60]="";
char trozo1[20]="";
char trozo2[20]="";
char trozo3[20]="";

unsigned char codigo[65536];
int coi;

int parser(int modo);

int tipePrint=0;
int tipePrepo=0;
int tipeBin=0;

int z,zz,z0,z1,z2,z3,z5;
unsigned int nn;
unsigned char nl,nh;
int linea;

unsigned int nbytes;
unsigned int nnema;

char fileOut[20]="file.bin";

int main(int arg,char *argv[])
{
    printf("\nEnsamblador corez80 V3\n=======================\n");
    if(arg<2)
		{
        printf("ERROR Debes incluir fichero.asm\n");
        printf("Formato:  ensam  fichero.asm \n");
        printf("\t\t-pt Salida por pantalla\n");
        printf("\t\t-ptn Salida por pantalla nemotecnico\n");
        //printf("\t\t-pp Salida por pantalla preprocesador\n");
        printf("\t\t-pb Salida por pantalla binario\n");
        printf("\t\t-o nombre fichero binario\n");
        return(-1);
		}

	for(z=1;z<arg;z++)
     {
      if( !strcmp(argv[z],"-pt"))  { tipePrint=1;}
      if( !strcmp(argv[z],"-ptn"))  { tipePrint=2;}
      //if( !strcmp(argv[z],"-pp"))  { tipePrepo=1;}
      if( !strcmp(argv[z],"-pb"))  { tipeBin=1;}
      if( !strcmp(argv[z],"-o"))  { sprintf(fileOut,"%s",argv[z+1]); z++;}
     }
    
// Procesar
    pf=fopen(argv[1] ,"rb");
    if(pf==NULL){ printf("ERROR abriendo fichero %s\n",argv[1]); return(-1);    }

	if(-1==preprocesador(tipePrepo) ){ printf(" ERROR en preprocesador\n"); return(-1);  }  
    fclose(pf);
	  
    pf=fopen("debug.asm","r");
    if(pf==NULL){ printf("ERROR abriendo fichero debug.asm \n"); return(-1);    }   
    
    nnema=sizeof(nema)/sizeof(nema[1]);
    printf("Num NEMOS= %d\n",nnema );
    
// Ensamblar    
    
    nvariables=0;
    fseek(pf,0,0);
 
    z=parser(0);
    if(z==-1) {printError(); goto saltoE;}
    
    fseek(pf,0,0);	
    z=parser(1);
    if(z==-1) {printError(); goto saltoE;}
  
    fclose(pf);  
    if(z==-1) printError();
    
saltoE:     
    printVariables();   
// Salvar codigo    
    saveCodigo(tipeBin);
    printf("\n");

    return(0);
}



// Parser de Ensamblado  _______________________________________
int parser(int modo)
{
 int tama;
 linea=0; coi=0;
    printf("--- Paser %i ===Ensamblador===\n",modo);
   do
    {
		linea++;
        fgets(lineaE,LINEMAX,pf); 
        tama=strlen(lineaE);
        for(z=0;z<LINEMAX;z++) if(lineaE[z]<32) lineaE[z]=0;
        if(modo==1)  printf("%03i %-16s  ",linea,lineaE);
        // comentario
        if(lineaE[0]=='/' || lineaE[0]==';') 	{  if(modo==1) printf("\n"); 			goto salto2; } 
		//Detecta si la linea esta vacia	
        if(tama<2) 		{ if(modo==1) printf("\n");  				goto salto2; } 
        lineaE[tama-1]=0;       
        indice=0; etiqueta[0]=0; trozo2[0]=0; trozo3[0]=0;
        
        if(0<buscarEtiquetas(modo)) goto salto2;
		if(-1==cambioEtiquetas(modo,'#') ) {	printError(); return(-1);		}
		if(-1==cambioEtiquetas(modo,'$') ) {	printError(); return(-1);		}
     	
		if( strstr(lineaE," DB ") )
            {	if(modo==1 && tipePrint==2) printf("%-16s     %05d_"," ",coi);
				if(-1==setBytes(1)) return(-1);
				printf("\n");	goto salto2;
			}
		if( strstr(lineaE," DW ") )
            {	if(modo==1 && tipePrint==2) printf("%-16s     %05d_"," ",coi);
				if(-1==setBytes(2)) return(-1);
				printf("\n");	goto salto2;
			}
		if( strstr(lineaE," DS ") )
            {	if(modo==1 && tipePrint==2) printf("%-16s     %05d_"," ",coi);
				if(-1==setString()) return(-1);
				printf("\n");	goto salto2;
			}
        buscarNumero(); 	//Busca numero decimal y lo cambia por N
        if(modo==1 && tipePrint==2) printf(" %-16s\t",lineaE);  
        //busqueda rapida_____________________________________________
 			z0=buscarCode();
			if(z0!=-1)
				{				
					if(modo==1) printf("   %05d_",coi);
					if(z1==0 && z2==1){ printf("_FIN__Parser %d \n",modo); break;}
					if(z1==0 && z2==2){ if(modo==1) printf("______ORG_%d",nn); coi=nn; goto salto0;}
					
					codigo[coi]=z2;  coi++; 
					// c==24 || c==56 || c==48 || c==40 || c==32 || c==233 || c==16 || c==205
					if(z2==16 || z2==24 || z2==32 || z2==40 || z2==48 || z2==56)
						{
							//printf("  coi=%d  nn=%d  DIF=%d  ",coi,nn,(nn-coi)-1);
							codigo[coi]=(nn-coi)-1;  coi++;  
							goto salto0;
						}
					if(z2==203) 	//BIT
							{ 
								codigo[coi]=z3;  coi++; 
								goto salto0; 
							} 		
					if(z2==221 || z2==253) 	//IX-221   IY-253
							{ 
								codigo[coi]=z3;  coi++;  
								if(z1==3) 	{ codigo[coi]=nl;  coi++; }	
								if(z1==4) 
									{
									 if(z3==203)
										 {  codigo[coi]=nl;  coi++; codigo[coi]=z5;  coi++; }
										else
										 {  codigo[coi]=nl;  coi++; codigo[coi]=nh;  coi++; }
									}
								goto salto0; 
							}		
					if(z2==237) 	//ED - 237
							{	
								codigo[coi]=z3;  coi++; 
								if(z1==4) { codigo[coi]=nl;  coi++; codigo[coi]=nh;  coi++; } 
								goto salto0;
							}			
					if(z1==2) 	{ codigo[coi]=nl;  coi++;   goto salto0;}	
					if(z1==3) 	{ codigo[coi]=nl;  coi++; codigo[coi]=nh;  coi++;  goto salto0;}						
salto0:			
					if(modo==1)
						{	
							for(z=z1;z>0;z--) printf(" %03d",codigo[coi-z]);
							printf("\n");
						}   
					goto salto2;												  
				}
			else
				{
					printf("_ERROR   _%03i_%s_\n",linea,lineaE);
					return(-1);	
				}          	
salto2:    
;
    } while(feof(pf)==0);
   
    //if(modo==1)     printVariables();
    return(0);
}

 



int buscarCode(void)
{
 int z,zz;
	//quita espacios a la izquierda
	zz=0;
	for(z=0;z<60;z++){	if(lineaE[z]>32) break;}	
	for(;z<60;z++)
        {
			trozo0[zz]=lineaE[z];
			if(lineaE[z]>31) zz++;
			if(lineaE[z]==0) break;
		}
   for(z=0;z<nnema;z++) 
    {
		//printf(">>%03i _TROZO0>_%s___NEMO>_%s_\n",z,trozo0,nemo[z]);
		if( !strcmp(nema[z].nemo,trozo0) )
            {
             z1=nema[z].n;
             z2=nema[z].code;
             z3=nema[z].code2;
             z5=nema[z].code4;
             return(z)  ;
            } 
    }
 return(-1);	
}



// Busca numero y lo cambia por N
int buscarNumero(void)
{
 int z;
 char numero[15];
 int i=0;
	for(z=0;z<40 && lineaE[z]!=0;z++)
		{
		  if(lineaE[z]=='&')
		  {
			  numero[i]='&'; i++;
			  z++;
			  for(;z<40;z++)
				{
				 if(lineaE[z]>47 && lineaE[z]<58)
					{
					  numero[i]=lineaE[z];
					  i++;
					}					
					else
					{
					  numero[i]=0;
					  nn=atoi(numero+1);
					  nl=nn&255;
					  nh=(nn>>8)&255;
					  changeSrt(lineaE,numero,"N");
					  return(1);
					}	
				}
		   }
		}
 return(-1);
}


// Busca etiquetas y la añade a la lista de variables. 
// Debe empezar la linea por # o $
int buscarEtiquetas(int modo)
{
	if(lineaE[0]=='$')  //VARIABLES
			{
			 if(modo==1 && tipePrint==2) printf("%s", lineaE);
             for(z=0;z<20;z++,indice++)
                {
					 if(lineaE[indice]<33)
					 {
						etiqueta[z]=0;					
						strcpy(variables[nvariables].nombre,etiqueta);
						indice++;
						variables[nvariables].valor=atoi(lineaE+indice);
						if (modo==0)nvariables++;
						if(modo==1)printf("\n");
						return(1);
					 }
                 etiqueta[z]=lineaE[indice];
                }
			}
		
	if(lineaE[0]=='#')    //Variables de salto
			{
			  for(z=0;z<20;z++,indice++)
							{
								 if(lineaE[indice]<33)
								 {
									etiqueta[z]=0;
									strcpy(variables[nvariables].nombre,etiqueta);
									indice++;
									if(modo==1 && tipePrint==2)printf("%-16s\t   %05d ",variables[nvariables].nombre,coi);
									variables[nvariables].valor=coi;
									if (modo==0)nvariables++;
									if(modo==1) printf("\n");
									return(2);
								 }
								 etiqueta[z]=lineaE[indice];
							}
			}
 return(-1);
}




// Transforma las  etiquetas en numeros
int cambioEtiquetas(int modo,char c)
{
  int z,z1,zz;    
  char var[20];
  
     for(z=1;z<20;z++)
        {	
			if(lineaE[z]==c)
				{
				 var[0]=c; z1=z+1;	  
				 for(zz=1;zz<20;zz++,z1++)
						{
							var[zz]=lineaE[z1];
							if( lineaE[z1]<48 || lineaE[z1]>90 ) break;							
						}
				 var[zz]=0; 
				 for(zz=0;zz<nvariables;zz++)
						{
							if( 0==strcmp(var,variables[zz].nombre) )
								{
									sprintf(var,"&%d",variables[zz].valor);
									changeSrt(lineaE, variables[zz].nombre,var);
									return(0);
								}
						}
				 if(modo==1) return(-1);
				 lineaE[z]='&';		 z++;
				 for(;z<20;z++)
					{
						if(lineaE[z]<48 || lineaE[z]>90) break;
						lineaE[z]='0';						
					}
				 return(0);
				}			
		}  
return(0);  				
}





int setBytes(int n)  //1-1Byte   2-2Bytes
{
 int z=0;
 char numero[15];
 int i;
	for(;z<40 && lineaE[z]!=0;z++)
		{
			  if(lineaE[z]=='&')
			  {
				  i=0; z++;
				  for(;z<40;z++)
					{
						 if(lineaE[z]>47 && lineaE[z]<58)
							{
							  numero[i]=lineaE[z];	  i++;
							}
							else
							{
								numero[i]=0; i=0;
								nn=atoi(numero); 
								if(n==1)
								{
								 codigo[coi]=nn;	coi++;
								 if(nn>255) return(-1);
								}
								else
								{
									nl=nn&255;	  nh=(nn>>8)&255;
									codigo[coi]=nl;	coi++;
									codigo[coi]=nh;	coi++;
									if(nn>65536) return(-1);
								}
								
								//printf(" ->%s  %d\n",numero,nn);
								goto saltox;
							}
					}				  
			  }
saltox:	
;
		}
 return(0);	
}


int setString(void)  //coloca cadenas en memoria
{
 int z;
	for(z=4;z<40 && lineaE[z]!=0;z++)
		{
		 codigo[coi]=lineaE[z]; coi++;
		 //printf(" ->%d  %c\n",z,lineaE[z]);
		}
	codigo[coi]=0;  coi++;
 return(0);	
}






void printError(void)
{
     printf(" ****ERROR  %03i %s\n",linea-1,lineaE);
}



void printVariables(void)
{
 int z;
    printf("\n==Variables== NUM=%d\n",nvariables-1);
    
    for(z=0;z<VARMAX;z+=3)
        {
         if(z>=nvariables) break;
         printf("%02d-%s=%i\t\t",z,variables[z].nombre,variables[z].valor);
         if((z+1)<nvariables) printf("%02d-%s=%i\t\t",z+1,variables[z+1].nombre,variables[z+1].valor);
         if((z+2)<nvariables) printf("%02d-%s=%i\n",z+2,variables[z+2].nombre,variables[z+2].valor);
        }
}


int saveCodigo(int modo)
{
 int z;
 FILE *pfbin;
	 printf("\nSalvando codigo en fichero %s   SIZE=%d\n",fileOut,coi);
	 pfbin=fopen(fileOut,"wb");
	 if(pf==NULL){ printf("ERROR abriendo fichero  %s\n",fileOut); return(-1);    }
	 for(z=0;z<coi;z++)
		 {
			putc(codigo[z],pfbin);
			if(modo==1)printf("%d,",codigo[z]);
		 }
	 fclose(pfbin);
	 return(0);
}






//__________________________PREPRO___________________________________________

int preprocesador(int modo)
{
	printf("--- Preprocesador ---\n");
	
	pfasm=fopen("debug.asm" ,"w");
    if(pfasm==NULL){ printf("ERROR creando fichero debug.asm \n");  fclose(pf); return(-1);    }
    
	do
	{
		linea++; indice=0;
        fgets(lineaE,LINEMAX,pf);
        lineaE[strlen(lineaE)-1]=0;
        //printf("%s\n",lineaE);
        if( lineaE[0]=='/' || lineaE[0]==';')
				{
				 if(modo==1) printf("%03d %s\n",linea,lineaE);
				 goto salto;
				}
		for(z=0;z<LINEMAX;z++) { if(lineaE[z]=='/' || lineaE[0]==';')lineaE[z]=0;  }		
        Mayusculas();
        quitarSPACE();
        quitarFinLinea();
       
        changeSrt(lineaE," ,",",");
        changeSrt(lineaE,", ",",");
        if(modo==1) printf("%03d %s\n",linea,lineaE);
        
        if(lineaE[0]=='$' )  //VARIABLES
        {
            for(z=0;z<20;z++,indice++)
                {
                 if(lineaE[indice]<33)
                 {
                    etiqueta[z]=0;
                    strcpy(variables[nvariables].nombre,etiqueta);
                    indice++;                    
                    variables[nvariables].valor=atoi(lineaE+indice);                    
                    nvariables++;
                    goto salto;
                 }
                 etiqueta[z]=lineaE[indice];
                }
        }
                
salto:
        fprintf(pfasm,"%s\n",lineaE);
    ;
    } while(feof(pf)==0);   

    fclose(pfasm);
    printf("--- Fin preprocesador ---\n");
    return(0);
}



int changeSrt(char *cadena, char *busqueda, char *cambio)
{
 char *pu;
 int z,zz,i;
 int taBusqueda;
 char bufferS[LINEMAX];
 
		taBusqueda=strlen(busqueda); if(taBusqueda==0) return(0);
		pu=strstr(cadena,busqueda);
		if( pu==NULL )
				{ return(0);}
			else
				{
				 z=pu-cadena;
				 for(i=0;i<LINEMAX && i<z;i++) { bufferS[i]=cadena[i];}
				 for(zz=0;i<LINEMAX ;i++,zz++) {  bufferS[i]=cambio[zz]; if(cambio[zz]==0)break;}
				 z+=taBusqueda;
				 for(;i<LINEMAX ;i++,z++){ bufferS[i]=cadena[z]; if(cadena[z]==0)break; }
				 bufferS[LINEMAX-1]=0;
				 strcpy(cadena,bufferS);	
				}
 return(1);	
}	

int quitarSPACE(void)
{
  int z,z1=0,sp=0;
  unsigned char lineaE1[LINEMAX];

    for (z = 0; z < LINEMAX ; z++)
        {
            lineaE1[z1]=lineaE[z];          
            if(lineaE[z]==32)
                sp++;
              else
                sp=0;
            if(sp<2 ) z1++;
            if(lineaE[z]==0)break;
        }
    for (z=0;z<LINEMAX;z++)
        {
           lineaE[z]=lineaE1[z];
           if(lineaE[z]==0)break;
        }
 return 0;
}


//todo Mayusculas y quitar caracteres menores de 32
int Mayusculas(void)
{
  int z,f1;
  char *z1;
  
	z1=strstr(lineaE,"ds ");   
	if(0==z1)
		{	f1=0;	}
	else
		{	f1=1; *z1='D';		z1++;		*z1='S'; }
  
    for (z = 0; z < LINEMAX && lineaE[z]!=0 ; z++)
        {
         if (f1==0 && lineaE[z] > 96 && lineaE[z] < 123) lineaE[z] -= 32; //mayusculas
         if (lineaE[z] < 32 ) lineaE[z] = 32;
        }
  return 0;
}



//quitarFinLinea
int quitarFinLinea(void)
{
 int z,z1=0;
  unsigned char lineaE1[LINEMAX];
    for (z = 0; z < LINEMAX ; z++,z1++)
        {
            lineaE1[z1]=lineaE[z];
            if(lineaE[z]==0)
            {
				if(z>0 && lineaE[z-1]==32) lineaE1[z-1]=0;
				break;
			}
        }
    for (z=0;z<LINEMAX;z++)
        {
           lineaE[z]=lineaE1[z];
           if(lineaE[z]==0)break;
        }
 return 0;
}

