#define _CASO0_ 

#include "caso0.h"
#include "main.h"
#include "cpu.h"

int caso0(unsigned char c)
{
  char salto;
		switch(nz) 
		{
		 case 0:
			switch(ny) //y
				{
				 case 0:
					   if(tipePrint==1) sprintf(cnemo,"NOP");
				 break;
				 case 1:
					   if(tipePrint==1) sprintf(cnemo,"EX AF,AF'");
					   alu16.w=af.w;	af.w=af2.w;	 af2.w=alu16.w;
				 break;
				 case 2:
					 if(tipePrint==1)   sprintf(cnemo,"DJNZ N");
					 printf("--CB-ERROR-c3-ns=%d-nd=%d- %s-\n",nz,ny,cnemo);	return(-1);
				 break;
				 case 3:
					  xPC++; salto=memoria[xPC];
					  if(tipePrint==1) sprintf(cnemo,"JR %d",salto);
					  xPC+=salto; xPC++; return(-2);
				 break;
				 default:
					  xPC++; salto=memoria[xPC];						
					  if(tipePrint==1) sprintf(cnemo,"JR %s,%d",fReg[ny-4],salto);
					  if(1==getF(ny-4)) { xPC+=salto; xPC++; return(-2);}
				 break;
				}
			
		 break;
		 
		 case 1:
				if(nq==0) 
				{
					xPC++; alu16.b.l=memoria[xPC];			
					xPC++; alu16.b.h=memoria[xPC];
					if(tipePrint==1)  sprintf(cnemo,"LD %s,%d",qqReg[np+modo],alu16.w);
					alu32=alu16.w;	Alu32ToReg(np);	
				}
				else
				{
					if(tipePrint==1) sprintf(cnemo,"ADD HL,%s",qqReg[np+modo]);	
					regToAlu32(np);		alu32+=hl.w;    hl.w=alu32;
					if((alu32&0x10000)==0x10000) regF1.CF=1; else regF1.CF=0; 
				}
		 break;
		 
		 
		 case 2:	 
			if(nq==0) 
				{
					switch(np)
						{
						 case 0:
							 if(tipePrint==1) sprintf(cnemo,"LD (BC),A");
							 memoria[bc.w]=af.b.h;
						 break;
						 case 1:
							 if(tipePrint==1) sprintf(cnemo,"LD (DE),A");
							 memoria[de.w]=af.b.h;						
						 break;
						 case 2:
							 if(tipePrint==1)  sprintf(cnemo,"LD (N),HL");
								xPC++; alu16.b.l=memoria[xPC];			
								xPC++; alu16.b.h=memoria[xPC];
								alu16i.w=hl.w;
								alu16.w=hl.w;	
								memoria[alu16.w]=alu16i.b.l;
								alu16.w++;
								memoria[alu16.w]=alu16i.b.h;
						 break;
						 case 3:
							if(tipePrint==1)  sprintf(cnemo,"LD (N),A");
							xPC++; alu16.b.l=memoria[xPC];			
							xPC++; alu16.b.h=memoria[xPC];	
							memoria[alu16.w]=af.b.h;	
						 break;
						}		
				}
				else
				{
					switch(np)
						{
						 case 0:
							 if(tipePrint==1)  sprintf(cnemo,"LD A,(BC)");
							 af.b.h=memoria[bc.w];
						 break;
						 case 1:
							 if(tipePrint==1)  sprintf(cnemo,"LD A,(DE)");
							 af.b.h=memoria[de.w];						
						 break;
						 case 2:
							 if(tipePrint==1)  sprintf(cnemo,"LD HL,(N)");
							 xPC++; alu16.b.l=memoria[xPC];						
							 xPC++; alu16.b.h=memoria[xPC];
							 hl.w=alu16.w;									
						 break;
						  case 3:
							 if(tipePrint==1)  sprintf(cnemo,"LD (N),A");
							 xPC++; alu16.b.l=memoria[xPC];			
							 xPC++; alu16.b.h=memoria[xPC];	
							 memoria[alu16.w]=af.b.h;						
						 break;
						}
				}
				
		 break;
		 case 3:
			
			if(nq==0) 
			{
				    if(tipePrint==1)  sprintf(cnemo,"INC %s",qqReg[np+modo]);
					switch(np)
					{
					 case 0:
						bc.w++;
					 break;
					 case 1:
						de.w++;
					 break;
					 case 2: 
						hl.w++;						
					 break;
					 case 3:
						rSP++;
					 break;
					}						
			}
			else
			{
				    if(tipePrint==1)  sprintf(cnemo,"DEC %s",qqReg[np+modo]);
					switch(np)
					{
					 case 0:
						bc.w--;
					 break;
					 case 1:
						de.w--;
					 break;
					 case 2:
						hl.w--;		
					 break;
					 case 3:
						rSP--;
					 break;
					}						
			}	 
		 break;
		 
		 case 4:
			regToAlu(ny);	alu++;	setF();	aluToReg(ny);
			if(tipePrint==1)  	sprintf(cnemo,"INC %s ",printReg8_d(ny));
		 break;
		 case 5:
			regToAlu(ny);	alu--;	setF();	aluToReg(ny);				
			if(tipePrint==1)  sprintf(cnemo,"DEC %s ",printReg8_d(ny));
		 break;
		 case 6:
		 	xPC++;		alu=memoria[xPC];
			aluToReg(ny);
			if(tipePrint==1)  	sprintf(cnemo,"LD %s n ",printReg8_d(ny));
		 break;
		 case 7:
			switch(ny)
					{
					 case 0:
						if(tipePrint==1)  	sprintf(cnemo,"RLCA");
						alu=af.b.h;
						alu<<=1;
						if(alu & 256) alu|=1; else alu&=254;
						setF();
						af.b.h=alu;
					 break;
					 case 1:
						if(tipePrint==1)     sprintf(cnemo,"RRCA");
						alu=af.b.h;						
						if((alu&1)==1)
							{	alu>>=1;	alu|=128;	alu|=256;}
							else
							{	alu>>=1;	alu&=127;	alu&=255;}						  
						setF();
						af.b.h=alu;								
					 break;
					 case 2:
						 if(tipePrint==1)    sprintf(cnemo,"RLA");
						alu=af.b.h;						
						if(regF1.CF==1)
							{	alu<<=1;	alu|=1;	}
							else
							{	alu<<=1;	alu&=65534;	}
						  
						setF();
						af.b.h=alu;						 
					break;
					 case 3:
						 if(tipePrint==1)    sprintf(cnemo,"RRA");
						alu=af.b.h;	
						alu16.b.h=alu&1;					
						if(regF1.CF==1)
							{	alu>>=1;	alu|=128;	}
							else
							{	alu>>=1;	alu&=127;	}
						if(alu16.b.h==1)
							{alu|=256;}
							else
							{alu&=0x2ff;}
						setF();
						af.b.h=alu;		
						
					 break;
					 case 4:
						 if(tipePrint==1)    sprintf(cnemo,"DAA");
						 printf("---ERROR-c3-ns=%d-nd=%d- %s-\n",nz,ny,cnemo);return(-1);	
					 break;
					 case 5:
						 if(tipePrint==1)    sprintf(cnemo,"CPL");
						 alu=af.b.h;	
						 alu=~alu;
						 af.b.h=alu;						
					 break;
					 case 6:
						 if(tipePrint==1)    sprintf(cnemo,"SCF");
						regF1.CF=1;	
					 break;
					 case 7:
					    if(tipePrint==1)  sprintf(cnemo,"CCF");
						if(regF1.CF==1)  regF1.CF=0; else regF1.CF=1;						
					 break;
					}		
		 break;
		 
		  
		}	
		
		
	
	 return(1);	
					
	}

