;pantalla.asm
; borrado , lineas verticales - horizontales
; ./sima file.bin        -t 0   -vi 1000
;seta43

	org &0
	ld sp,&4000
	jp #inicio

/--------------intINT--
    org &56
#intINT
	
#salirINT
	reti


/--------------intNMI--
    org &102
#salirNMI

	retn
/----------------------


#inicio	
	ld d,&255    /:
	call #CLS
	
	ld d,&0    /:
	call #CLS
	
	ld de,&0
	ld b,&120
	ld c,&120
	call #BOX
	
	halt
	jp #inicio

		
#CLS		/ Borrar pantalla	d=valor relleno
	ld hl,&16384
	ld bc,&2048
#cls1
	ld (hl),d
	dec bc
	inc hl
	ld a,b
	or c
	jr nz,#cls1
	ret

/ box	de=x,y    bc=xx,yy
#BOX
	ld h,b
	ld l,c
	
	/ld d,d
	/ld e,e
	ld b,d
	ld c,l	
	call #LINE
	
	ld a,d
	ld d,h
	/ld e,e
	ld b,h
	ld c,l	
	call #LINE
	
	ld d,a
	/ld e,e
	ld b,h
	ld c,e	
	call #LINE
	
	/ld d,d
	ld e,l
	ld b,h
	ld c,l	
	call #LINE

	ret
		
/lineas horizontales y verticales 	/de=x,y    bc=xx,yy	
#LINE
	push af
	push bc
	push de
	push hl
	ld a,c
	cp e
	jr z,#linew
#line2	
	call #PLOT
	inc e
	cp e
	jr nz,#line2
	jr #linex
#linew
	ld a,b
#line3
	call #PLOT
	inc d
	cp d
	jr nz,#line3
#linex
	pop hl
	pop de
	pop bc
	pop af	
	ret

#PLOT		/ plot d=x,e=y
	push af
	push bc
	push de
	push hl
	ld a,&16
	ld b,&0	/bc=y
	ld c,e
	ld h,&0	/hl=0
	ld l,&0
#plot1
	add hl,bc	/*16
	dec a
	jr nz,#plot1
	ld bc,&16384	/16384+y*16
	add hl,bc
	ld b,&0
	ld c,d
	srl c	/ /8
	srl c
	srl c	/byte
	add hl,bc
	sla c	/ *8
	sla c
	sla c	
	ld a,d
	sub c
	ld b,&128
	ld c,&0
#plot3
	cp c
	jr z,#plot2
	srl b
	dec a
	jr #plot3
#plot2
	ld a,(hl)
	or b
	ld (hl),a
	pop hl
	pop de
	pop bc
	pop af	
	ret
	
	halt
	
	end

	
	
	
	
