/caracter.asm
;./sima file.bin   -t 0   -vi 300   -port 0 -nmi -int  
/seta43

	org &0
   	ld sp,&4000
   	jp #empezar

/--------------intINT--
    org &56
#intINT
	in a,(&0)	
	call #teclado
#salirINT
	ld a,&255
	out (&0),a
	reti


/--------------intNMI--
    org &102
#intNMI
	call #reloj
	retn
/----------------------


   org &200
#empezar

	ld hl,#spuntos	
	ld d,&0		/X
	ld e,&6	/Y
	call #prints

	ld ix,&16384  
	ld a,&0    /0
	ld (ix+&9),a		/segundos
	ld (ix+&10),a		/minutos
	ld (ix+&11),a		/horas
	ld a,&58    /:
    ld (ix+&2),a
    ld (ix+&5),a
	
	ei 

	
; ---BUCLE principal
#bucle
	

	nop
	jr #bucle
	
	
;---DIVIDIR------	
	/num=a   Salida-> b=unidades  c=decenas
#dividir10	
	ld c,&0
#div10
	cp &10
	jp m,#div10a	/negativo
	sub &10
	inc c
	jr #div10
#div10a
	add a,&48
	ld b,a	
	ld a,&48
	add a,c
	ld c,a		
	ret	
	
/---------------------------------

	org &300	
#reloj
	push af
	ld ix,&16384
	inc (ix+&9)			/incrementar segundos
	ld a,&60    /60
	cp (ix+&9)
	jr nz,#xreloj
	ld a,&0
	ld (ix+&9),a
	inc (ix+&10)		/incrementa minutos
	ld a,&60   /60
	cp (ix+&10)
	jr nz,#xreloj
	ld a,&0
	ld (ix+&10),a
	inc (ix+&11)		/incrementa horas
	ld a,&24    /24
	cp (ix+&11)
	jr nz,#xreloj
	ld a,&0
	ld (ix+&9),a
	ld (ix+&10),a
	ld (ix+&11),a
#xreloj
	call #dibujo
	pop af
	ret

/Dibujo de caracteres reloj 
#dibujo

	ld ix,&16384
	ld a,(ix+&9)		/segundos
	call #dividir10
	ld (ix+&6),c
    ld (ix+&7),b
    
    ld a,(ix+&10)		/minutos
	call #dividir10
	ld (ix+&3),c
    ld (ix+&4),b
    
    ld a,(ix+&11)		/horas
	call #dividir10
	ld (ix+&0),c
    ld (ix+&1),b

	/dibujo grafico
	ld a,(ix+&7)		
    ld d,&7
    ld e,&6
	call #printc
	
	ld a,(ix+&6)
    ld d,&6
    ld e,&6
	call #printc
	
	ld a,(ix+&4)
    ld d,&4
    ld e,&6
	call #printc
	
	ld a,(ix+&3)
    ld d,&3
    ld e,&6
	call #printc
	
	ld a,(ix+&1)
    ld d,&1
    ld e,&6
	call #printc
	
	ld a,(ix+&0)
    ld d,&0
    ld e,&6
	call #printc
			
	ret


	
#teclado
	cp &51
	jr z,#incseg
	cp &49
	jr z,#inchor
	cp &50
	jr z,#incmin	
	jr #xteclado
#incseg	
	ld a,&0				/borrar segundos
	ld (ix+&9),a	
	jr #xteclado	
#incmin
	inc (ix+&10)		/incrementa minutos
	ld a,&60   /60
	cp (ix+&10)
	jr nz,#xteclado
	ld a,&0
	ld (ix+&10),a
	jr #xteclado	
#inchor
	inc (ix+&11)		/incrementa horas	
	ld a,&24    /24
	cp (ix+&11)
	jr nz,#xteclado
	ld a,&0
	ld (ix+&11),a
#xteclado
	ret
	


;----------------------------------------------

	/print cadena____hl=direccion cadena____de=x,y_______
#prints
	push af
	push bc
	push de
	push hl
	push ix
#prints1
	ld a,(hl)
	cp &0
	jr z,#xprints
	call #printc
	inc hl
	inc d
	jr #prints1
#xprints	
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	ret



	/print caracter____a=caracter(ASCII)____de=x,y_______
#printc
	push af
	push bc
	push de
	push hl
	push ix
	
	sub &32
	
	ld ix,&16384	/X
	ld b,&0
	ld c,d
	add ix,bc
	
	ld bc,&128		/Y
	inc e
#printc5
	dec e
	jr z,#printc4
	add ix,bc
	jr #printc5
	
#printc4
	ld de,&8
	ld hl,#varnum
#printc0
	cp &0
	jr z,#printc2
	add hl,de
	dec a
	jr #printc0	
#printc2

	ld de,&16
	ld b,&8
#printc1
	ld a,(hl)
	ld (ix+&0),a
	inc hl
	add ix,de
	dec b
	jr nz,#printc1
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	ret

	nop
	nop
	nop

;___________cadenas
#ssreloj	
	ds RELOJ
#spuntos
	ds **:**:**


; Caracteres desde 32 al 127 procedentes del spectrum
	org &2000
#varnum
;__32_   
    db  &0,&0,&0,&0,
    db  &0,&0,&0,&0,
;__33_!  
    db  &0,&16,&16,&16,
    db  &16,&0,&16,&0,
;__34_"  
    db  &0,&36,&36,&0,
    db  &0,&0,&0,&0,
;__35_#  
    db  &0,&36,&126,&36,
    db  &36,&126,&36,&0,
;__36_$  
    db  &0,&8,&62,&40,
    db  &62,&10,&62,&8,
;__37_%  
    db  &0,&98,&100,&8,
    db  &16,&38,&70,&0,
;__38_&  
    db  &0,&16,&40,&16,
    db  &42,&68,&58,&0,
;__39_'  
    db  &0,&8,&16,&0,
    db  &0,&0,&0,&0,
;__40_(  
    db  &0,&4,&8,&8,
    db  &8,&8,&4,&0,
;__41_)  
    db  &0,&32,&16,&16,
    db  &16,&16,&32,&0,
;__42_*  
    db  &0,&0,&20,&8,
    db  &62,&8,&20,&0,
;__43_+  
    db  &0,&0,&8,&8,
    db  &62,&8,&8,&0,
;__44_,  
    db  &0,&0,&0,&0,
    db  &0,&8,&8,&16,
;__45_-  
    db  &0,&0,&0,&0,
    db  &62,&0,&0,&0,
;__46_.  
    db  &0,&0,&0,&0,
    db  &0,&24,&24,&0,
;__47_/  
    db  &0,&0,&2,&4,
    db  &8,&16,&32,&0,
;__48_0  
    db  &0,&60,&70,&74
    db  &82,&98,&60,&0
;__49_1  
    db  &0,&24,&40,&8
    db  &8,&8,&62,&0
;__50_2  
    db  &0,&60,&66,&2
    db  &60,&64,&126,&0
;__51_3  
    db  &0,&60,&66,&12
    db  &2,&66,&60,&0
;__52_4  
    db  &0,&8,&24,&40
    db  &72,&126,&8,&0
;__53_5  
    db  &0,&126,&64,&124
    db  &2,&66,&60,&0
;__54_6  
    db  &0,&60,&64,&124
    db  &66,&66,&60,&0
;__55_7  
    db  &0,&126,&2,&4
    db  &8,&16,&16,&0
;__56_8  
    db  &0,&60,&66,&60
    db  &66,&66,&60,&0
;__57_9  
    db  &0,&60,&66,&66
    db  &62,&2,&60,&0
;__58_:  
    db  &0,&0,&0,&16
    db  &0,&0,&16,&0
;__59_;  
    db  &0,&0,&16,&0
    db  &0,&16,&16,&32
;__60_<  
    db  &0,&0,&4,&8
    db  &16,&8,&4,&0
;__61_=  
    db  &0,&0,&0,&62
    db  &0,&62,&0,&0
;__62_>  
    db  &0,&0,&16,&8
    db  &4,&8,&16,&0
;__63_?  
    db  &0,&60,&66,&4
    db  &8,&0,&8,&0
;__64_@  
    db  &0,&60,&74,&86
    db  &94,&64,&60,&0
;__65_A  
    db  &0,&60,&66,&66
    db  &126,&66,&66,&0
;__66_B  
    db  &0,&124,&66,&124
    db  &66,&66,&124,&0
;__67_C  
    db  &0,&60,&66,&64
    db  &64,&66,&60,&0
;__68_D  
    db  &0,&120,&68,&66
    db  &66,&68,&120,&0
;__69_E  
    db  &0,&126,&64,&124
    db  &64,&64,&126,&0
;__70_F  
    db  &0,&126,&64,&124
    db  &64,&64,&64,&0
;__71_G  
    db  &0,&60,&66,&64
    db  &78,&66,&60,&0
;__72_H  
    db  &0,&66,&66,&126
    db  &66,&66,&66,&0
;__73_I  
    db  &0,&62,&8,&8
    db  &8,&8,&62,&0
;__74_J  
    db  &0,&2,&2,&2
    db  &66,&66,&60,&0
;__75_K  
    db  &0,&68,&72,&112
    db  &72,&68,&66,&0
;__76_L  
    db  &0,&64,&64,&64
    db  &64,&64,&126,&0
;__77_M  
    db  &0,&66,&102,&90
    db  &66,&66,&66,&0
;__78_N  
    db  &0,&66,&98,&82
    db  &74,&70,&66,&0
;__79_O  
    db  &0,&60,&66,&66
    db  &66,&66,&60,&0
;__80_P  
    db  &0,&124,&66,&66
    db  &124,&64,&64,&0
;__81_Q  
    db  &0,&60,&66,&66
    db  &82,&74,&60,&0
;__82_R  
    db  &0,&124,&66,&66
    db  &124,&68,&66,&0
;__83_S  
    db  &0,&60,&64,&60
    db  &2,&66,&60,&0
;__84_T  
    db  &0,&254,&16,&16
    db  &16,&16,&16,&0
;__85_U  
    db  &0,&66,&66,&66
    db  &66,&66,&60,&0
;__86_V  
    db  &0,&66,&66,&66
    db  &66,&36,&24,&0
;__87_W  
    db  &0,&66,&66,&66
    db  &66,&90,&36,&0
;__88_X  
    db  &0,&66,&36,&24
    db  &24,&36,&66,&0
;__89_Y  
    db  &0,&130,&68,&40
    db  &16,&16,&16,&0
;__90_Z  
    db  &0,&126,&4,&8
    db  &16,&32,&126,&0
;__91_[  
    db  &0,&14,&8,&8
    db  &8,&8,&14,&0
;__92_\  
    db  &0,&0,&64,&32
    db  &16,&8,&4,&0
;__93_]  
    db  &0,&112,&16,&16
    db  &16,&16,&112,&0
;__94_^  
    db  &0,&16,&56,&84
    db  &16,&16,&16,&0
;__95__  
    db  &0,&0,&0,&0
    db  &0,&0,&0,&255
;__96_`  
    db  &0,&28,&34,&120
    db  &32,&32,&126,&0
;__97_a  
    db  &0,&0,&56,&4
    db  &60,&68,&60,&0
;__98_b  
    db  &0,&32,&32,&60
    db  &34,&34,&60,&0
;__99_c  
    db  &0,&0,&28,&32
    db  &32,&32,&28,&0
;__100_d  
    db  &0,&4,&4,&60
    db  &68,&68,&60,&0
;__101_e  
    db  &0,&0,&56,&68
    db  &120,&64,&60,&0
;__102_f  
    db  &0,&12,&16,&24
    db  &16,&16,&16,&0
;__103_g  
    db  &0,&0,&60,&68
    db  &68,&60,&4,&56
;__104_h  
    db  &0,&64,&64,&120
    db  &68,&68,&68,&0
;__105_i  
    db  &0,&16,&0,&48
    db  &16,&16,&56,&0
;__106_j  
    db  &0,&4,&0,&4
    db  &4,&4,&36,&24
;__107_k  
    db  &0,&32,&40,&48
    db  &48,&40,&36,&0
;__108_l  
    db  &0,&16,&16,&16
    db  &16,&16,&12,&0
;__109_m  
    db  &0,&0,&104,&84
    db  &84,&84,&84,&0
;__110_n  
    db  &0,&0,&120,&68
    db  &68,&68,&68,&0
;__111_o  
    db  &0,&0,&56,&68
    db  &68,&68,&56,&0
;__112_p  
    db  &0,&0,&120,&68
    db  &68,&120,&64,&64
;__113_q  
    db  &0,&0,&60,&68
    db  &68,&60,&4,&6
;__114_r  
    db  &0,&0,&28,&32
    db  &32,&32,&32,&0
;__115_s  
    db  &0,&0,&56,&64
    db  &56,&4,&120,&0
;__116_t  
    db  &0,&16,&56,&16
    db  &16,&16,&12,&0
;__117_u  
    db  &0,&0,&68,&68
    db  &68,&68,&56,&0
;__118_v  
    db  &0,&0,&68,&68
    db  &40,&40,&16,&0
;__119_w  
    db  &0,&0,&68,&84
    db  &84,&84,&40,&0
;__120_x  
    db  &0,&0,&68,&40
    db  &16,&40,&68,&0
;__121_y  
    db  &0,&0,&68,&68
    db  &68,&60,&4,&56
;__122_z  
    db  &0,&0,&124,&8
    db  &16,&32,&124,&0
;__123_{  
    db  &0,&14,&8,&48
    db  &8,&8,&14,&0
;__124_|  
    db  &0,&8,&8,&8
    db  &8,&8,&8,&0
;__125_}  
    db  &0,&112,&16,&12
    db  &16,&16,&112,&0
;__126_~  
    db  &0,&20,&40,&0
    db  &0,&0,&0,&0
;__127_  
    db  &60,&66,&153,&161
    db  &161,&153,&66,&60
	
	end

	
